From be5177a39eb6088f1581f1727f5604d96ba78f33 Mon Sep 17 00:00:00 2001
From: Andrew Price <andrewprice@andrewalexanderprice.com>
Date: Sat, 27 Aug 2011 23:08:16 +0930
Subject: [PATCH 6/8] fixed yuv420 sbs

---
 STEREOSCOPY README                             |  173 +++++++++-----------
 include/vlc_es.h                               |   27 ---
 modules/gui/qt4/components/extended_panels.cpp |    5 +
 modules/gui/qt4/menus.cpp                      |    4 +-
 modules/gui/qt4/ui/video_effects.ui            |   99 +++++++++++-
 modules/video_filter/Modules.am                |    2 +
 modules/video_filter/stereoscopy.c             |   29 +++--
 modules/video_output/msw/Modules.am            |    2 +
 modules/video_output/msw/common.h              |   17 +--
 modules/video_output/msw/direct3d.c            |  208 ++++++++----------------
 10 files changed, 277 insertions(+), 289 deletions(-)

diff --git a/STEREOSCOPY README b/STEREOSCOPY README
index 249cf16..3fa40a4 100644
--- a/STEREOSCOPY README	
+++ b/STEREOSCOPY README	
@@ -1,12 +1,4 @@
 ================================================================================
-Before doing anything, be warned that there is a mixture of GPL and non-GPL
-software in this release, so under no circumstance should you publically
-release a binary version of this software yet. The non-GPL files are:
-vlc/include/nvapi.h
-nvapiwrapper/nvapi.lib
-nvapiwrapper/nvapiwrapper.dll
-nvapiwrapper/nvapiwrapper.c
-================================================================================
 To build follow the standard Win32Compile instructions with a few differences.
 I use 32-bit MSYS/MinGW on x64 Windows 7 Ultimate.
 
@@ -18,8 +10,6 @@ cp -v /usr/win32/share/aclocal/* m4/
 cp -v /usr/share/aclocal/* m4/
 PATH=/usr/win32/bin:$PATH ./bootstrap
 
-if it fails witH
-
 ================================================================================
 2. Then to configure:
 
@@ -53,101 +43,90 @@ activates for programs with a driver profile. Thankfully, it's just a simple
 file name check.
 
 ================================================================================
-5. Copy nvapiwrapper.dll from 'nvapiwrapper' to 'vlc-1.2.0-git':
-
-cp ../nvapiwrapper/nvapiwrapper.dll ./
-
-This is a temporary solution. See nvapiwrapper/README for more details.
-
-================================================================================
-6. To view 3D video you manually enable stereoscopy by running VLC with:
-
-wow --video-filter="stereoscopy" --stereoscopy-left=<left mode>            \
-    --stereoscopy-right=<right mode>
+5. To view 3D video you manually enable stereoscopy by running VLC with:
 
-<left mode> and <right mode> represent the method that particular eye is encoded
-with. For example, to watch a Red/Cyan anaglyph video you would use:
+wow --video-filter="stereoscopy"
 
-wow --video-filter="stereoscopy" --stereoscopy-left=1004                   \
-    --stereoscopy-right=1001
+You can pass the parameters --sterescopy-left= and --stereoscopy-right= to
+set the stereoscopy value for each eye.
 
-To watch a left/right side-by-side video you would use:
-wow --video-filter="stereoscopy" --stereoscopy-left=2000                   \
-    --stereoscopy-right=2001
+It's also possible to configure this via the QT4 interface by going to
+'Effects and Filters' through the Video menu. Search for the Stereoscopic 3D
+tab under the Video Effects tab.
 
-The possible values are: (found in modules/video_filter/stereoscopy.h)
+The possible stereoscopic input values are: (found in modules/video_filter/stereoscopy.h)
 --------------------------------------------------------------------------------
- 0     STEREOSCOPY_2D
-        If either eye is this value then stereoscopy is disabled and the image
-        is treated as 2D.
- 1000  STEREOSCOPY_ANAGLYPH_BLUE
-        The eye is encoded into the blue channel of the image and returned as
-        a blue image.
- 1001  STEREOSCOPY_ANAGLYPH_CYAN
-        The eye is encoded into the blue and green channels of the image and
-        returned as a cyan image.
- 1002  STEREOSCOPY_ANAGLYPH_GREEN
-        The eye is encoded into the green channel of the image and returned
-        as a green image.
- 1003  STEREOSCOPY_ANAGLYPH_MAGENTA
-        The eye is encoded into the red and blue channels of the image and
-        returned as a magenta image.
- 1004  STEREOSCOPY_ANAGLYPH_RED
-        The eye is encoded into the red channel of the image and returned as
-        a red image.
- 1005  STEREOSCOPY_ANAGLYPH_YELLOW
-        The eye is encoded into the red and green channels of the image and
-        returned as a yellow image.
-
- 1010  STEREOSCOPY_ANAGLYPH_BLUE_GRAY
-        The eye is encoded into the blue channel and returned as a grayscale
-        image.
- 1011  STEREOSCOPY_ANAGLYPH_CYAN_GRAY
-        The eye is encoded into the blue and green channels of the image and
-        returned as a grayscale image.
- 1012  STEREOSCOPY_ANAGLYPH_GREEN_GRAY
-        The eye is encoded into the green channel of the image and returned
-        as a grayscale image.
- 1013  STEREOSCOPY_ANAGLYPH_MAGENTA_GRAY
-        The eye is encoded into the red and blue channels of the image and
-        returned as a grayscale image.
- 1014  STEREOSCOPY_ANAGLYPH_RED_GRAY
-        The eye is encoded into the red channel of the image and returned
-        as a grayscale image.
- 1015  STEREOSCOPY_ANAGLYPH_YELLOW_GRAY
-        The eye is encoded into the red and green channels of the image and
-        returned as a grayscale image.
-
- 1021  STEREOSCOPY_ANAGLYPH_CYAN_FILL
-        The eye is encoded into the blue and green channels of the image and
-        returned as a full colour image. The missing red channel is filled in
-        with the average of the blue and green channels.
- 1023  STEREOSCOPY_ANAGLYPH_MAGENTA_FILL
-        The eye is encoded into the red and blue channels of the image and
-        returned as a full colour image. The missing green channel is filled in
-        with the average of the red and blue channels.
- 1025  STEREOSCOPY_ANAGLYPH_YELLOW_FILL
-        The eye is encoded into the red and green channels of the image and
-        returned as a full colour image. The missing blue channel is filled in
-        with the average of the red and green channels.
-
- 2000  STEREOSCOPY_SIDEBYSIDE_LEFT
-        The eye is encoded into the left half of the image. Assumes the source
-        is half-SBS but the aspect ratio will need to be halved for full-SBS.
- 2001  STEREOSCOPY_SIDEBYSIDE_RIGHT
-        The eye is encoded into the right half of the image. Assumes the source
-        is half-SBS but the aspect ratio will need to be halved for full-SBS.
- 2002  STEREOSCOPY_SIDEBYSIDE_BOTTOM
-        Not yet implemented. Reserved for top/bottom side-by-side.
- 2003  STEREOSCOPY_SIDEBYSIDE_TOP
-        Not yet implemented. Reserved for top/bottom side-by-side.
+ blue         STEREOSCOPY_ANAGLYPH_BLUE
+              The eye is encoded into the blue channel of the image and
+              returned as a blue image.
+ cyan         STEREOSCOPY_ANAGLYPH_CYAN
+              The eye is encoded into the blue and green channels of the image
+              and returned as a cyan image.
+ green        STEREOSCOPY_ANAGLYPH_GREEN
+              The eye is encoded into the green channel of the image and
+              returned as a green image.
+ magenta      STEREOSCOPY_ANAGLYPH_MAGENTA
+              The eye is encoded into the red and blue channels of the image
+              and returned as a magenta image.
+ red          STEREOSCOPY_ANAGLYPH_RED
+              The eye is encoded into the red channel of the image and returned
+              as a red image.
+ yellow       STEREOSCOPY_ANAGLYPH_YELLOW
+              The eye is encoded into the red and green channels of the image
+              and returned as a yellow image.
+
+ blue-gray    STEREOSCOPY_ANAGLYPH_BLUE_GRAY
+              The eye is encoded into the blue channel and returned as a
+              grayscale image.
+ cyan-gray    STEREOSCOPY_ANAGLYPH_CYAN_GRAY
+              The eye is encoded into the blue and green channels of the image
+              and returned as a grayscale image.
+ green-gray   STEREOSCOPY_ANAGLYPH_GREEN_GRAY
+              The eye is encoded into the green channel of the image and
+              returned as a grayscale image.
+ magenta-gray STEREOSCOPY_ANAGLYPH_MAGENTA_GRAY
+              The eye is encoded into the red and blue channels of the image
+              and returned as a grayscale image.
+ red-gray  STEREOSCOPY_ANAGLYPH_RED_GRAY
+              The eye is encoded into the red channel of the image and returned
+              as a grayscale image.
+ yellow-gray  STEREOSCOPY_ANAGLYPH_YELLOW_GRAY
+              The eye is encoded into the red and green channels of the image
+              and returned as a grayscale image.
+
+ cyan-fill    STEREOSCOPY_ANAGLYPH_CYAN_FILL
+              The eye is encoded into the blue and green channels of the image
+              and returned as a full colour image. The missing red channel is
+              filled in with the average of the blue and green channels.
+ magenta-fill STEREOSCOPY_ANAGLYPH_MAGENTA_FILL
+              The eye is encoded into the red and blue channels of the image
+              and returned as a full colour image. The missing green channel
+              is filled in with the average of the red and blue channels.
+ yellow-fill  STEREOSCOPY_ANAGLYPH_YELLOW_FILL
+              The eye is encoded into the red and green channels of the image
+              and returned as a full colour image. The missing blue channel is
+              filled in with the average of the red and green channels.
+
+ left         STEREOSCOPY_SIDEBYSIDE_LEFT
+              The eye is encoded into the left half of the image. Assumes the
+              source is half-SBS but the aspect ratio will need to be halved
+              for full-SBS.
+ right        STEREOSCOPY_SIDEBYSIDE_RIGHT
+              The eye is encoded into the right half of the image. Assumes the
+              source is half-SBS but the aspect ratio will need to be halved
+              for full-SBS.
+ bottom       STEREOSCOPY_SIDEBYSIDE_BOTTOM
+              The eye is encoded into the bottom half of the image. Assumes the
+              source is half-SBS but the aspect ratio will need to be halved
+              for full-SBS.
+ top          STEREOSCOPY_SIDEBYSIDE_TOP
+              The eye is encoded into the top half of the image. Assumes the
+              source is half-SBS but the aspect ratio will need to be halved
+              for full-SBS.
 --------------------------------------------------------------------------------
 Please only use the Direct3D vout because the other vout's are not stereoscopic
 aware and will just sequentually show each eye. Also be sure to use the latest
 nVidia drivers. (I have been developing with 275.22.)
 
 The Direct3D vout does not require any configuring. If 3D Vision is detected
-then it will be used. It can be enabled/disabled using the button on the
-3D Vision IR dongle or by using the driver hotkey (CTRL+T by default). If 3D
-Vision is turned off then it does not turn the stereoscopy filter off, so you'll
-just see the left eye.
+and a 3D video frames are being sent to it then it will be displayed in 3D!
diff --git a/include/vlc_es.h b/include/vlc_es.h
index 4f50e7e..1537154 100644
--- a/include/vlc_es.h
+++ b/include/vlc_es.h
@@ -99,33 +99,6 @@ struct audio_format_t
  * video format description
  */
  
-/**
- * stereoscopic formats
- * sbs = side by side
- * anaglyph = each eye is encoded in a colour channel
- * field sequential = each eye is stored in alternating frames
- */
-#define VIDEO_FORMAT_STEREOSCOPY_2D (0)                            /** no 3d */
-#define VIDEO_FORMAT_STEREOSCOPY_SBS_FULL_HORIZONTAL (1)
-#define VIDEO_FORMAT_STEREOSCOPY_SBS_HALF_HORIZONTAL (2)
-#define VIDEO_FORMAT_STEREOSCOPY_SBS_FULL_VERTICAL (3)
-#define VIDEO_FORMAT_STEREOSCOPY_SBS_HALF_VERTICAL (4)
-#define VIDEO_FORMAT_STEREOSCOPY_ANAGLYPH_RED_GREEN (5)
-#define VIDEO_FORMAT_STEREOSCOPY_ANAGLYPH_RED_BLUE (6)
-#define VIDEO_FORMAT_STEREOSCOPY_ANAGLYPH_RED_CYAN (7)
-#define VIDEO_FORMAT_STEREOSCOPY_ANAGLYPH_GREEN_BLUE (8)
-#define VIDEO_FORMAT_STEREOSCOPY_ANAGLYPH_GREEN_MAGENTA (9)
-#define VIDEO_FORMAT_STEREOSCOPY_ANAGLYPH_BLUE_YELLOW (10)
-#define VIDEO_FORMAT_STEREOSCOPY_FIELD_SEQUENTIAL (11)
-                     /** fill in the missing colour channels with the average
-					                                   of the other channels */
-											     
-#define VIDEO_FORMAT_STEREOSCOPY_ANAGLYPH_FILL_CHANNELS (0x20000000)
-                                             /** swap the colour of each eye */
-#define VIDEO_FORMAT_STEREOSCOPY_ANAGLYPH_SWAP_EYES (0x40000000)
-#define VIDEO_FORMAT_STEREOSCOPY_SWAP_EYES (0x80000000)        /** flip eyes */
-/*    unsigned int i_stereoscopy;              *//**stereoscopy format*/
-
 struct video_format_t
 {
     vlc_fourcc_t i_chroma;                               /**< picture chroma */
diff --git a/modules/gui/qt4/components/extended_panels.cpp b/modules/gui/qt4/components/extended_panels.cpp
index 340e49a..d6fb930 100644
--- a/modules/gui/qt4/components/extended_panels.cpp
+++ b/modules/gui/qt4/components/extended_panels.cpp
@@ -242,6 +242,11 @@ ExtVideo::ExtVideo( intf_thread_t *_p_intf, QTabWidget *_parent ) :
         _parent->removeTab( _parent->indexOf( ui.tab_atmo ) );
     }
 
+	SETUP_VFILTER( stereoscopy )
+    SETUP_VFILTER_OPTION( stereoscopicLeftCombo, currentIndexChanged( QString ) )
+	SETUP_VFILTER_OPTION( stereoscopicRightCombo, currentIndexChanged( QString ) )
+
+
 #undef SETUP_VFILTER
 #undef SETUP_VFILTER_OPTION
 
diff --git a/modules/gui/qt4/menus.cpp b/modules/gui/qt4/menus.cpp
index a8653b6..4470dd9 100644
--- a/modules/gui/qt4/menus.cpp
+++ b/modules/gui/qt4/menus.cpp
@@ -239,8 +239,7 @@ static int VideoAutoMenuBuilder( vout_thread_t *p_object,
     PUSH_VAR( "deinterlace" );
     PUSH_VAR( "deinterlace-mode" );
     PUSH_VAR( "postprocess" );
-    PUSH_VAR( "stereoscopy" );
-
+    
     return VLC_SUCCESS;
 }
 
@@ -652,7 +651,6 @@ QMenu *QVLCMenu::VideoMenu( intf_thread_t *p_intf, QMenu *current, bool b_subtit
         addActionWithSubmenu( current, "deinterlace", qtr( "&Deinterlace" ) );
         addActionWithSubmenu( current, "deinterlace-mode", qtr( "&Deinterlace mode" ) );
         addActionWithSubmenu( current, "postprocess", qtr( "&Post processing" ) );
-        addActionWithSubmenu( current, "stereoscopy", qtr( "&Stereoscopy" ) );
     }
 
     p_input = THEMIM->getInput();
diff --git a/modules/gui/qt4/ui/video_effects.ui b/modules/gui/qt4/ui/video_effects.ui
index 6455894..df35f10 100644
--- a/modules/gui/qt4/ui/video_effects.ui
+++ b/modules/gui/qt4/ui/video_effects.ui
@@ -11,7 +11,7 @@
    </rect>
   </property>
   <property name="currentIndex">
-   <number>0</number>
+   <number>7</number>
   </property>
   <widget class="QWidget" name="tab">
    <attribute name="title">
@@ -1609,6 +1609,103 @@
     </item>
    </layout>
   </widget>
+  <widget class="QWidget" name="tab_4">
+   <attribute name="title">
+    <string>Stereoscopic 3D</string>
+   </attribute>
+   <widget class="QGroupBox" name="stereoscopyEnable">
+    <property name="geometry">
+     <rect>
+      <x>10</x>
+      <y>10</y>
+      <width>511</width>
+      <height>101</height>
+     </rect>
+    </property>
+    <property name="title">
+     <string>Split</string>
+    </property>
+    <property name="checkable">
+     <bool>true</bool>
+    </property>
+    <property name="checked">
+     <bool>false</bool>
+    </property>
+    <layout class="QGridLayout" name="_5">
+     <item row="1" column="0">
+      <widget class="QLabel" name="label_52">
+       <property name="text">
+        <string>Left Eye</string>
+       </property>
+      </widget>
+     </item>
+     <item row="2" column="1">
+      <widget class="QComboBox" name="stereoscopicRightCombo"/>
+     </item>
+     <item row="2" column="0">
+      <widget class="QLabel" name="label_53">
+       <property name="text">
+        <string>Right Eye</string>
+       </property>
+      </widget>
+     </item>
+     <item row="1" column="1">
+      <widget class="QComboBox" name="stereoscopicLeftCombo"/>
+     </item>
+     <item row="0" column="0" colspan="2">
+      <widget class="QLabel" name="label_51">
+       <property name="text">
+        <string>Splits a stereoscopic 3d source image into two images.</string>
+       </property>
+       <property name="wordWrap">
+        <bool>true</bool>
+       </property>
+      </widget>
+     </item>
+    </layout>
+   </widget>
+   <widget class="QGroupBox" name="stereoscopyCombineEnable">
+    <property name="geometry">
+     <rect>
+      <x>10</x>
+      <y>120</y>
+      <width>511</width>
+      <height>91</height>
+     </rect>
+    </property>
+    <property name="title">
+     <string>Combine</string>
+    </property>
+    <property name="checkable">
+     <bool>true</bool>
+    </property>
+    <property name="checked">
+     <bool>false</bool>
+    </property>
+    <layout class="QGridLayout" name="_7">
+     <item row="2" column="1">
+      <widget class="QComboBox" name="stereoscopicOutputCombo"/>
+     </item>
+     <item row="2" column="0">
+      <widget class="QLabel" name="label_55">
+       <property name="text">
+        <string>Output Format</string>
+       </property>
+      </widget>
+     </item>
+     <item row="1" column="0" colspan="2">
+      <widget class="QLabel" name="label_54">
+       <property name="text">
+        <string>Combines seperate left and right source images into a single stereoscopic 3d image. Leave this disabled for the individual left and right images to be passed through to the video out module.</string>
+       </property>
+       <property name="wordWrap">
+        <bool>true</bool>
+       </property>
+      </widget>
+     </item>
+    </layout>
+   </widget>
+  </widget>
  </widget>
  <tabstops>
   <tabstop>adjustEnable</tabstop>
diff --git a/modules/video_filter/Modules.am b/modules/video_filter/Modules.am
index a86fb20..d424a92 100644
--- a/modules/video_filter/Modules.am
+++ b/modules/video_filter/Modules.am
@@ -58,6 +58,7 @@ SOURCES_swscale = swscale.c ../codec/avcodec/chroma.c
 SOURCES_scene = scene.c
 SOURCES_sepia = sepia.c
 SOURCES_stereoscopy = stereoscopy.c
+SOURCES_stereoscopycombine = stereoscopycombine.c
 SOURCES_yuvp = yuvp.c
 SOURCES_antiflicker = antiflicker.c
 SOURCES_atmo = atmo/atmo.cpp \
@@ -126,6 +127,7 @@ libvlc_LTLIBRARIES += \
 	libsharpen_plugin.la \
 	libsubsdelay_plugin.la \
 	libstereoscopy_plugin.la \
+	libstereoscopycombine_plugin.la \
 	libtransform_plugin.la \
 	libwall_plugin.la \
 	libwave_plugin.la \
diff --git a/modules/video_filter/stereoscopy.c b/modules/video_filter/stereoscopy.c
index fc9c4a0..424a305 100644
--- a/modules/video_filter/stereoscopy.c
+++ b/modules/video_filter/stereoscopy.c
@@ -880,19 +880,23 @@ static picture_t *Filter( filter_t *p_filter, picture_t *p_inpic )
     {
         case VLC_CODEC_I411:
             chromaformat = 411;
+			/* msg_Err( p_filter, "stereoscopy.c video is yuv_411"); */
             break;
         case VLC_CODEC_I420:
         case VLC_CODEC_J420:
             chromaformat = 420;
+			/* msg_Err( p_filter, "stereoscopy.c video is yuv_420"); */
             break;
         case VLC_CODEC_YV12:
         case VLC_CODEC_I422:
         case VLC_CODEC_J422:
             chromaformat = 422;
+			/* msg_Err( p_filter, "stereoscopy.c video is yuv_422"); */
             break;
         case VLC_CODEC_I444:
         case VLC_CODEC_J444:
             chromaformat = 444;
+			/* msg_Err( p_filter, "stereoscopy.c video is yuv_444"); */
             break;
         default:
             msg_Err( p_filter, "Unsupported input chroma (%4.4s)",
@@ -3215,6 +3219,7 @@ static void get_lefthalf_from_yuv420( filter_t *p_filter, picture_t *p_inpic, pi
     const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
     const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
 
+
     const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
     while( y1in < yend )
     {
@@ -3261,8 +3266,9 @@ static void get_lefthalf_from_yuv420( filter_t *p_filter, picture_t *p_inpic, pi
             y2in++;
 
         }
-        y1in  += (i_visible_pitch / 2) + i_in_pitch - i_visible_pitch;
-        y1out += i_out_pitch - i_visible_pitch;
+		/* skip two y lines because this is yuv420 */
+        y1in  += (i_visible_pitch / 2) + (i_in_pitch * 2)- i_visible_pitch;
+        y1out += (i_out_pitch * 2) - i_visible_pitch;
         uin   += (i_uv_visible_pitch / 2) + p_inpic->p[up].i_pitch - i_uv_visible_pitch;
         uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
         vin   += (i_uv_visible_pitch / 2) + p_inpic->p[vp].i_pitch - i_uv_visible_pitch;
@@ -3422,8 +3428,10 @@ static void get_righthalf_from_yuv420( filter_t *p_filter, picture_t *p_inpic,
             y2in++;
 
         }
-        y1in  += i_in_pitch  - i_visible_pitch;
-        y1out += i_out_pitch - i_visible_pitch;
+		
+		/* skip two y lines because this is yuv420 */
+        y1in  += i_in_pitch * 2  - i_visible_pitch;
+        y1out += i_out_pitch * 2 - i_visible_pitch;
         uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
         uout  += p_outpic->p[up].i_pitch - i_uv_visible_pitch;
         vin   += p_inpic->p[vp].i_pitch  - i_uv_visible_pitch;
@@ -3537,13 +3545,13 @@ static void get_tophalf_from_yuv420( filter_t *p_filter, picture_t *p_inpic, pic
     const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
     const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
 
-    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    const uint8_t *yend = y1in + (i_visible_lines / 2) * i_in_pitch;
     
     while( y1in < yend )
     {
         const uint8_t *y1end = y1in + i_visible_pitch;
         y2in  = y1in + i_in_pitch;
-        y2out = y1out + i_out_pitch;
+        y2out = y1out + i_out_pitch * 2;
         while( y1in < y1end )
         {
 			*(y1out + i_out_pitch) = *y1out = *y1in;
@@ -3637,13 +3645,13 @@ static void get_bottomhalf_from_yuv420( filter_t *p_filter, picture_t *p_inpic,
     const int i_visible_lines = p_inpic->p[yp].i_visible_lines;
     const int i_uv_visible_pitch = p_inpic->p[up].i_visible_pitch;
 
-    const uint8_t *yend = y1in + i_visible_lines * i_in_pitch;
+    const uint8_t *yend = y1in + (i_visible_lines / 2) * i_in_pitch;
     
     while( y1in < yend )
     {
         const uint8_t *y1end = y1in + i_visible_pitch;
         y2in  = y1in + i_in_pitch;
-        y2out = y1out + i_out_pitch;
+        y2out = y1out + i_out_pitch * 2;
         while( y1in < y1end )
         {
 			*(y1out + i_out_pitch) = *y1out = *y1in;
@@ -3666,13 +3674,14 @@ static void get_bottomhalf_from_yuv420( filter_t *p_filter, picture_t *p_inpic,
 
 			*(uout + p_outpic->p[up].i_pitch) = *uout = *uin;
 			*(vout + p_outpic->p[vp].i_pitch) = *vout = *vin;
-
-
+			
             uin++;
             vin++;
             uout++;
             vout++;
         }
+		
+		/* skip two y lines because this is yuv420 */
         y1in  += 2*i_in_pitch  - i_visible_pitch;
         y1out += 4*i_out_pitch - i_visible_pitch;
         uin   += p_inpic->p[up].i_pitch - i_uv_visible_pitch;
diff --git a/modules/video_output/msw/Modules.am b/modules/video_output/msw/Modules.am
index fec095b..433b9da 100644
--- a/modules/video_output/msw/Modules.am
+++ b/modules/video_output/msw/Modules.am
@@ -20,6 +20,8 @@ SOURCES_direct3d = \
 	events.h \
 	events.c \
 	common.c \
+        nvapi.c \
+        nvapi.h \
 	$(NULL)
 
 SOURCES_glwin32 = \
diff --git a/modules/video_output/msw/common.h b/modules/video_output/msw/common.h
index 8a71a64..f47e1be 100644
--- a/modules/video_output/msw/common.h
+++ b/modules/video_output/msw/common.h
@@ -30,7 +30,7 @@
 
 #ifdef MODULE_NAME_IS_direct3d
 /* assume d3d9.h has alreayd been included */
-#include <nvapi.h>
+#include "nvapi.h"
 #endif
 
 #ifdef MODULE_NAME_IS_wingapi
@@ -208,13 +208,6 @@ struct vout_display_sys_t
                                               loaded? if false then can
                                               assume dll is not loaded */
     void                    *nvStereoHandle; /* 3d vision stereo handle */
-    void                    *nvInitializeFunc; /* NvAPI_Initialize */
-    void                    *nvUnloadFunc; /* NvAPI_Unload */
-    void                    *nvStereoIsEnabledFunc; /* NvAPI_Stereo_IsEnabled */
-    void                    *nvStereoEnableFunc ; /* NvAPI_Stereo_Enable */
-    void                    *nvStereoCreateHandleFunc; /* NvAPI_Stereo_CreateHandleFromIUnknown */
-    void                    *nvStereoIsActivatedFunc; /* NvAPI_Stereo_IsActivated */
-    void                    *nvStereoDestroyHandleFunc; /* NvAPI_Stereo_DestroyHandle */
 
     RECT                    nvRectLeft;
     RECT                    nvRectRight;
@@ -225,14 +218,14 @@ struct vout_display_sys_t
     LPDIRECT3DVERTEXBUFFER9 d3dvtc;
     int                     d3dregion_count;
     struct d3d_region_t     *d3dregion;
-	/* Stereoscopic scene objects */
+    /* Stereoscopic scene objects */
     LPDIRECT3DTEXTURE9      d3dtex_right; /* store right eye, d3dtex for left */
     LPDIRECT3DSURFACE9      d3dnv_surface;
     LPDIRECT3DSURFACE9      d3dback_buffer;
     LPDIRECT3DSURFACE9      d3dleft_surface;
-	LPDIRECT3DSURFACE9      d3dright_surface;
-	bool                    left_tex_filled;
-	bool                    right_tex_filled;
+    LPDIRECT3DSURFACE9      d3dright_surface;
+    bool                    left_tex_filled;
+    bool                    right_tex_filled;
 
     picture_resource_t      resource;
 
diff --git a/modules/video_output/msw/direct3d.c b/modules/video_output/msw/direct3d.c
index bf2d0cf..49bc47b 100644
--- a/modules/video_output/msw/direct3d.c
+++ b/modules/video_output/msw/direct3d.c
@@ -152,10 +152,6 @@ static int DesktopCallback(vlc_object_t *, char const *, vlc_value_t, vlc_value_
  */
 static int Open(vlc_object_t *object)
 {
-    /* Temporary warning */
-    MessageBoxA(NULL, "This build of VLC is uses priority code from NVAPI and is not to be redistributed to binary format.",
-        "Licensing Warning", MB_OK);
-
     vout_display_t *vd = (vout_display_t *)object;
     vout_display_sys_t *sys;
 
@@ -516,116 +512,36 @@ static void Manage (vout_display_t *vd)
 static int NvCreate(vout_display_t *vd)
 {
     vout_display_sys_t *sys = vd->sys;
-    sys->hNvAPIWrapper_dll = LoadLibrary(TEXT("nvapiwrapper.dll"));
-    if(!sys->hNvAPIWrapper_dll) {
-        MessageBoxA(NULL, "Cannot find nvapiwrapper.dll. Is it in the VLC directory?",
-        "nvapiwrapper.dll", MB_ICONERROR);
-        sys->use_nvidia_3d = false;
-        return VLC_EGENERIC;
-    }
-
-    /* load in function pointers */
-    sys->nvInitializeFunc = (void *)GetProcAddress(sys->hNvAPIWrapper_dll,
-        TEXT("_NvAPIWrapper_Initialize@0"));
-    if(!sys->nvInitializeFunc) {
-        msg_Err(vd, "Cannot locate NvAPIWrapper_Initialize in DLL");
-        FreeLibrary(sys->hNvAPIWrapper_dll);
-        sys->use_nvidia_3d = false;
-        return VLC_EGENERIC;
-    }
-
-    sys->nvUnloadFunc = (void *)GetProcAddress(sys->hNvAPIWrapper_dll,
-        TEXT("_NvAPIWrapper_Unload@0"));
-    if(!sys->nvUnloadFunc) {
-        msg_Err(vd, "Cannot locate NvAPIWrapper_Unload in DLL");
-        FreeLibrary(sys->hNvAPIWrapper_dll);
-        sys->use_nvidia_3d = false;
-        return VLC_EGENERIC;
-    }
-
-    sys->nvStereoIsEnabledFunc = (void *)GetProcAddress(sys->hNvAPIWrapper_dll,
-        TEXT("_NvAPIWrapper_Stereo_IsEnabled@4"));
-    if(!sys->nvStereoIsEnabledFunc) {
-        msg_Err(vd, "Cannot locate NvAPIWrapper_Stereo_IsEnabled in DLL");
-        FreeLibrary(sys->hNvAPIWrapper_dll);
-        sys->use_nvidia_3d = false;
-        return VLC_EGENERIC;
-    }
-
-    sys->nvStereoEnableFunc = (void *)GetProcAddress(sys->hNvAPIWrapper_dll,
-        TEXT("_NvAPIWrapper_Stereo_Enable@0"));
-    if(!sys->nvStereoEnableFunc) {
-        msg_Err(vd, "Cannot locate NvAPIWrapper_Stereo_Enable in DLL");
-        FreeLibrary(sys->hNvAPIWrapper_dll);
-        sys->use_nvidia_3d = false;
-        return VLC_EGENERIC;
-    }
-
-    sys->nvStereoCreateHandleFunc = (void *)GetProcAddress(sys->hNvAPIWrapper_dll,
-        TEXT("_NvAPIWrapper_Stereo_CreateHandleFromIUnknown@8"));
-    if(!sys->nvStereoCreateHandleFunc) {
-        msg_Err(vd, "Cannot locate NvAPIWrapper_Stereo_CreateHandleFromIUnknown in DLL");
-        FreeLibrary(sys->hNvAPIWrapper_dll);
-        sys->use_nvidia_3d = false;
-        return VLC_EGENERIC;
-    }
-
-    sys->nvStereoIsActivatedFunc = (void *)GetProcAddress(sys->hNvAPIWrapper_dll,
-        TEXT("_NvAPIWrapper_Stereo_IsActivated@8"));
-    if(!sys->nvStereoIsActivatedFunc) {
-        msg_Err(vd, "Cannot locate NvAPIWrapper_Stereo_IsActivated in DLL");
-        FreeLibrary(sys->hNvAPIWrapper_dll);
-        sys->use_nvidia_3d = false;
-        return VLC_EGENERIC;
-    }
-
-    sys->nvStereoDestroyHandleFunc = (void *)GetProcAddress(sys->hNvAPIWrapper_dll,
-        TEXT("_NvAPIWrapper_Stereo_DestroyHandle@4"));
-    if(!sys->nvStereoDestroyHandleFunc) {
-        msg_Err(vd, "Cannot locate NvAPIWrapper_Stereo_DestroyHandle in DLL");
-        FreeLibrary(sys->hNvAPIWrapper_dll);
-        sys->use_nvidia_3d = false;
-        return VLC_EGENERIC;
-    }
-
-    /* now try initialising nvapi */
-    NvAPI_Status (WINAPI *NvAPIWrapper_Initialise)();
-    NvAPIWrapper_Initialise = sys->nvInitializeFunc;
-
-    NvAPI_Status (WINAPI *NvAPIWrapper_Unload)();
-    NvAPIWrapper_Unload = sys->nvUnloadFunc;
-
-    NvAPI_Status (WINAPI *NvAPIWrapper_Stereo_IsEnabled)(NvU8 *pIsStereoEnabled);
-    NvAPIWrapper_Stereo_IsEnabled = sys->nvStereoIsEnabledFunc;
-
-    NvAPI_Status (WINAPI *NvAPIWrapper_Stereo_Enable)(void);
-    NvAPIWrapper_Stereo_Enable = sys->nvStereoEnableFunc;
-
-    if(NvAPIWrapper_Initialise() == NVAPI_OK)
+    
+    /* try initialising nvapi */
+    if(NvAPI_Initialize() == NVAPI_OK)
     {
         /* not returning NVAPI_OK for Initialise() could mean bad drivers or
            not using an nVidia card */
-        NvU8 stereoEnabled;
-        if(NvAPIWrapper_Stereo_IsEnabled(&stereoEnabled) != NVAPI_OK)
+        unsigned char stereoEnabled;
+        if(NvAPI_Stereo_IsEnabled(&stereoEnabled) != NVAPI_OK)
         {
             /* not returning NVAPI_OK for Stereo_IsEnabled could possibly mean
                an unsupported video card or not running Windows Vista/7 */
-            msg_Err(vd, "NV stereo did not want to enable");
-            NvAPIWrapper_Unload();
-            FreeLibrary(sys->hNvAPIWrapper_dll);
+            msg_Warn(vd, "Cannot check if NVAPI 3d Vision is enabled. Bad drive or not using compatible card.");
+            NvAPI_Unload();
             sys->use_nvidia_3d = false;
             return VLC_EGENERIC;
         }
         else
         {
-            if(stereoEnabled == 0)
-                NvAPIWrapper_Stereo_Enable();
+			if(!stereoEnabled)
+			{
+			    msg_Warn(vd, "NVAPI 3d Vision is disabled. Enable in nVidia Control Panel or not using compatible card.");
+			    NvAPI_Unload();
+			    sys->use_nvidia_3d = false;
+			    return VLC_EGENERIC;
+			}
         }
     }
     else
     {
-        msg_Err(vd, "NvAPI did not want to initialize");
-        FreeLibrary(sys->hNvAPIWrapper_dll);
+        msg_Warn(vd, "NvAPI did not want to initialize. Bad driver or not using nVidia card.");
         sys->use_nvidia_3d = false;
         return VLC_EGENERIC;
     }
@@ -690,12 +606,7 @@ static void NvDestroy(vout_display_t *vd)
 
     sys->use_nvidia_3d = false;
 
-    NvAPI_Status (WINAPI *NvAPIWrapper_Unload)();
-    NvAPIWrapper_Unload = sys->nvUnloadFunc;
-
-    NvAPIWrapper_Unload();
-
-    FreeLibrary(sys->hNvAPIWrapper_dll);
+    NvAPI_Unload();
 }
 
 /**
@@ -814,15 +725,10 @@ static int Direct3DOpen(vout_display_t *vd, video_format_t *fmt)
     /* attempt to create a d3d device */
     if(sys->use_nvidia_3d)
     {
-        NvAPI_Status (WINAPI *NvAPIWrapper_Stereo_CreateHandleFromIUnknown)
-            (IUnknown *pDevice, StereoHandle *pStereoHandle);
-        NvAPIWrapper_Stereo_CreateHandleFromIUnknown =
-            sys->nvStereoCreateHandleFunc;
-
-        if(NvAPIWrapper_Stereo_CreateHandleFromIUnknown(sys->d3ddev,
+        if(NvAPI_Stereo_CreateHandleFromIUnknown(sys->d3ddev,
             &sys->nvStereoHandle) != NVAPI_OK)
         {
-	    msg_Err(vd, "Could not create a stereo handle.");
+        msg_Err(vd, "Could not create a stereo handle.");
             NvDestroy(vd);
         }
     }
@@ -852,10 +758,7 @@ static void Direct3DClose(vout_display_t *vd)
     if(sys->use_nvidia_3d)
     {
         /* destroy stereo handle */
-        NvAPI_Status (WINAPI *NvAPIWrapper_Stereo_DestroyHandle)(
-            StereoHandle stereoHandle);
-        NvAPIWrapper_Stereo_DestroyHandle = sys->nvStereoDestroyHandleFunc;
-        NvAPIWrapper_Stereo_DestroyHandle(sys->nvStereoHandle);
+        NvAPI_Stereo_DestroyHandle(sys->nvStereoHandle);
     }
 
     if (sys->d3ddev)
@@ -881,10 +784,7 @@ static int Direct3DReset(vout_display_t *vd)
     if(sys->use_nvidia_3d)
     {
         /* destroy stereo handle */
-        NvAPI_Status (WINAPI *NvAPIWrapper_Stereo_DestroyHandle)(
-            StereoHandle stereoHandle);
-        NvAPIWrapper_Stereo_DestroyHandle = sys->nvStereoDestroyHandleFunc;
-        NvAPIWrapper_Stereo_DestroyHandle(sys->nvStereoHandle);
+        NvAPI_Stereo_DestroyHandle(sys->nvStereoHandle);
     }
 
     /* */
@@ -897,15 +797,10 @@ static int Direct3DReset(vout_display_t *vd)
     /* attempt to create a d3d device */
     if(sys->use_nvidia_3d)
     {
-        NvAPI_Status (WINAPI *NvAPIWrapper_Stereo_CreateHandleFromIUnknown)
-            (IUnknown *pDevice, StereoHandle *pStereoHandle);
-        NvAPIWrapper_Stereo_CreateHandleFromIUnknown =
-            sys->nvStereoCreateHandleFunc;
-
-        if(NvAPIWrapper_Stereo_CreateHandleFromIUnknown(sys->d3ddev,
+        if(NvAPI_Stereo_CreateHandleFromIUnknown(sys->d3ddev,
             &sys->nvStereoHandle) != NVAPI_OK)
         {
-	    msg_Err(vd, "Could not create a stereo handle.");
+        msg_Err(vd, "Could not create a stereo handle.");
             NvDestroy(vd);
         }
     }
@@ -1678,33 +1573,68 @@ static int Direct3DRenderRegion(vout_display_t *vd,
         sys->use_nvidia_3d)
     {
         /* check to see if stereo is turned on */
-        NvAPI_Status (WINAPI *NvAPIWrapper_Stereo_IsActivated)(
-	StereoHandle stereoHandle, NvU8 *pIsStereoOn);
-        NvAPIWrapper_Stereo_IsActivated = sys->nvStereoIsActivatedFunc;
-
-        NvU8 stereoOn;
-        if(NvAPIWrapper_Stereo_IsActivated(sys->nvStereoHandle, &stereoOn) == NVAPI_OK)
-            drawInStereo = (bool)stereoOn;
+        unsigned char stereoOn;
+        if(NvAPI_Stereo_IsActivated(sys->nvStereoHandle, &stereoOn) == NVAPI_OK)
+		{
+			if(!stereoOn)
+			{
+				/* activate 3d vision because it's not yet turned on */
+				NvAPI_Stereo_Activate(sys->nvStereoHandle);
+			}
+
+			/* check again */
+			if(NvAPI_Stereo_IsActivated(sys->nvStereoHandle, &stereoOn) == NVAPI_OK)
+			{
+				drawInStereo = (bool)stereoOn;
+			}
+			else
+				drawInStereo = false;
+		}
         else
             drawInStereo = false;
     }
     else
+	{
+		if(sys->use_nvidia_3d)
+		{
+			/* check if stereo is on */
+            unsigned char stereoOn;
+			if(NvAPI_Stereo_IsActivated(sys->nvStereoHandle, &stereoOn) == NVAPI_OK)
+			{
+				if(stereoOn)
+				{
+					/* deactivate 3d vision because it's turned on (saves wireless glass's power
+					  to disable when not viewing 3d) */
+					NvAPI_Stereo_Deactivate(sys->nvStereoHandle);
+				}
+			}
+
+		}
         drawInStereo = false;
+	}
 
     if(drawInStereo)
     {
         /* draw stereoscopic image */
 
         RECT dest = sys->rect_dest_clipped;
+        /* work around for anyone reading this code:
+            showing right image on left half of stereo surface, then showing
+            left image on right half of stereo surface, and using the
+            DXNV_SWAP_EYES flag
+
+            For some reason stereomode wouldn't work correctly without
+            that flag.
+        */
         /* copy left and right image to stereo surface*/
-        IDirect3DDevice9_StretchRect(sys->d3ddev, sys->d3dleft_surface,
-            &sys->nvRectLeft, sys->d3dnv_surface, &dest,
+        IDirect3DDevice9_StretchRect(sys->d3ddev, sys->d3dright_surface,
+            &sys->nvRectLeft/*&sys->rect_src_clipped*/, sys->d3dnv_surface, &dest,
             D3DTEXF_NONE);
 
-        dest.left += sys->rect_display.right;
+        dest.left = sys->rect_display.right;
         dest.right += sys->rect_display.right;
-        IDirect3DDevice9_StretchRect(sys->d3ddev, sys->d3dright_surface,
-            &sys->nvRectLeft, sys->d3dnv_surface, &dest,
+        IDirect3DDevice9_StretchRect(sys->d3ddev, sys->d3dleft_surface,
+            &sys->nvRectLeft/*&sys->rect_src_clipped*/, sys->d3dnv_surface, &dest,
             D3DTEXF_NONE);
 
         /* write in the nvidia header */
-- 
1.7.4.msysgit.0

